[impulse, fs_impulse] = audioread("1st_baptist_nashville_far_close.wav"); %インパルス応答ファイルの読み込み
impulse = impulse(:,1);                                      %片chのみ抽出
[audio, fs_audio] = audioread("VSQSE_965_cat_6.wav");        %入力音声の読み込み
audio = audio(:,1);                                          %片chのみ抽出
audio = resample(audio, fs_impulse, fs_audio);               %入力音声のサンプリング周波数をインパルス応答のサンプリング周波数に揃える
audio = [audio;zeros(fs_impulse*3,1)];                       %入力音声の末尾に3秒の無音を付加
filter_out = filter(impulse, 1, audio);                      %読み込んだインパルス応答を使って入力音声にFIRフィルタを適用
filter_out = filter_out / max(abs(filter_out));              %最大値が1になるよう正規化
soundsc(filter_out, fs_impulse, 16)                          %FIRフィルタの出力を音声として再生
audiowrite("cat_nashville.wav",filter_out, fs_impulse);

impulse_len = length(impulse);                                  
t = (0:(impulse_len-1))/fs_impulse;
plot(t,impulse);                                             %インパルス応答をプロット
xlabel("Time[s]")

figure;
f = (0:1:(impulse_len-1))/impulse_len * fs_impulse;
db = 20*log10( abs( fft( impulse ) ) );
plot( f, db );
xlabel("Frequency[Hz]");
ylabel("Magnitude[dB]");
xlim([0 fs_impulse/2]);
